//-------------------------------------------------------------------------------------------------
// Animation.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_Animation_
#define _include_Animation_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"
//typedef Texture Animation;

///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Animation
// 
///////////////////////////////////////////////////////////////////////////////////////////////////

class Animation
{
private:
public:
	/// Constructors / destructors
	Animation( const std::string& filePath, float aFrate=10.0f, const Vector2& aScale=Vector2::ONE, float aRotDeg=0 ); // constructor
		// Takes (File Path, Frame Rate [per sec], scale, rotation)
	~Animation(); // destructor

	/// Public methods
	void Draw( const Vector2& screenCenterCoordinates, const Vector2& aScale=Vector2::ONE, float aRotDeg=0, const Rgba& color = Rgba::WHITE, int aDrawFrame=-666  );
		// Takes (Screen Coord, scale, rotation, frame to draw)
	int GetLoop();
		// returns the number of loop iterations that have occured
	void ResetAnim();
		// Reset loop count and frame number

	float frate;			// frame rate of the animation
	int framenum;			// number of frames in the animation
	int size;				// size of the animation in screen coord 32 = 32x32, 64 = 64x64, etc...
	int totalframes;		// total number of frames in the animation set
	int nexttick;			// the time for the next tick.
	Vector2 scale;			// scale of image
	float rotdeg;			// rotation in degrees
	double starttime;
	Texture* a_texture;		// The actual texture
	int loopcount;		// Number of loop iterations that have occured


};

#endif // _include_Animation_

