// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#include "pch.hpp"
#include "engineAssert.hpp"
#include "EntityDisplay.hpp"
#include "TheGame.hpp"

EntityDisplay::EntityDisplay()
{
}

EntityDisplay::~EntityDisplay()
{
}

void EntityDisplay::Draw( int currentMapNumber )
{
	MapData* mapdata = theGame->m_currentMap;
	std::list< Entity* >::iterator start = mapdata->entityList.begin();
	std::list< Entity* >::iterator end = mapdata->entityList.end();
	for( std::list< Entity* >::iterator cur = start; cur != end; cur++ )
	{
		Entity* e = *cur;

		if( e->m_anim )
		{
			float rotationDegrees = (float)e->m_rot;
			if( !e->m_drawRotated )
			{
				rotationDegrees = 0.0f;
			}

			e->m_anim->Draw( e->m_pos * 32, e->m_scale, rotationDegrees, e->m_color );
		}
	}
}