//-------------------------------------------------------------------------------------------------
// Entity_Barrel.cpp
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "engineAssert.hpp"
#include "Entity.hpp"
#include "Particle.hpp"
#include "TheGame.hpp"


//-------------------------------------------------------------------------------------------------
// Spawn_Barrel
//-------------------------------------------------------------------------------------------------
void Entity::Spawn_Barrel()
{
	m_anim = new Animation( "data/gfx/items/barrel.tga" );
	m_bounds.SetFromMinXYMaxXY( -16.0f, -16.0f, 16.0f, 16.0f );
	m_hitPoints = 10.0f;
	m_damageTakeMultiplier = 1.0f;
	m_drawRotated = false;
	m_isHitByPlayerBullets = true;
}


//-------------------------------------------------------------------------------------------------
// Think_Barrel
//-------------------------------------------------------------------------------------------------
void Entity::Think_Barrel()
{
}


//-------------------------------------------------------------------------------------------------
// Die_Barrel
//-------------------------------------------------------------------------------------------------
void Entity::Die_Barrel()
{
	int randomItemSpawn = RandomInt( 0 , 11 );
	if( randomItemSpawn == 1 )
	{
		SpawnNewEntity( ENT_ITEMPICKUP_MANA, m_pos );
	}
	else if( randomItemSpawn == 2 )
	{
		SpawnNewEntity( ENT_ITEMPICKUP_HEALTH, m_pos );
	}
	else if( randomItemSpawn == 3 )
	{
		SpawnNewEntity( ENT_ITEMPICKUP_BOMB, m_pos );
	}
	delete m_anim ;

	Particle* p = Particle::Spawn();
	p->m_pos = m_pos;
	p->m_startAlpha = 1.0f;
	p->m_endAlpha = 0.0f;
	p->m_startScale = 1.0f;
	p->m_endScale = 5.0f;
	p->m_timeToLive = 0.3;
	p->m_anim = new Animation( "data/gfx/particles/barrelExplode.tga" );
}



