//-------------------------------------------------------------------------------------------------
// Entity_Crate.cpp
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "engineAssert.hpp"
#include "Entity.hpp"
#include "Particle.hpp"
#include "TheGame.hpp"


//-------------------------------------------------------------------------------------------------
// Spawn_Crate
//-------------------------------------------------------------------------------------------------
void Entity::Spawn_Crate()
{
	m_anim = new Animation( "data/gfx/items/crate.tga" );
	m_bounds.SetFromMinXYMaxXY( -16.0f, -16.0f, 16.0f, 16.0f );
	m_hitPoints = 10.0f;
	m_damageTakeMultiplier = 1.0f;
	m_drawRotated = false;
	m_isHitByPlayerBullets = true;
}


//-------------------------------------------------------------------------------------------------
// Think_Crate
//-------------------------------------------------------------------------------------------------
void Entity::Think_Crate()
{
}


//-------------------------------------------------------------------------------------------------
// Die_Crate
//-------------------------------------------------------------------------------------------------
void Entity::Die_Crate()
{
	int randomItemSpawn = RandomInt( 0 , 14 );
	if( randomItemSpawn == 1 )
	{
		SpawnNewEntity( ENT_ITEMPICKUP_MANA, m_pos );
	}
	else if( randomItemSpawn == 2 )
	{
		SpawnNewEntity( ENT_ITEMPICKUP_HEALTH, m_pos );
	}
	else if( randomItemSpawn == 3 )
	{
		SpawnNewEntity( ENT_ITEMPICKUP_BOMB, m_pos );
	}

	delete m_anim ;

	Particle* p = Particle::Spawn();
	p->m_pos = m_pos;
	p->m_startAlpha = 1.0f;
	p->m_endAlpha = 0.0f;
	p->m_startScale = 1.0f;
	p->m_endScale = 5.0f;
	p->m_timeToLive = 0.3;
	p->m_anim = new Animation( "data/gfx/particles/crateExplode.tga" );
}



