//-------------------------------------------------------------------------------------------------
// Entity_GeneratorMushroom.cpp
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "engineAssert.hpp"
#include "Entity.hpp"
#include "TheGame.hpp"


const float MAX_SPAWNER_ACTIVE_DISTANCE = 10.0f;


//-------------------------------------------------------------------------------------------------
// Spawn_GeneratorMushroom
//-------------------------------------------------------------------------------------------------
void Entity::Spawn_GeneratorMushroom()
{
	m_objectSpawnPeriodSeconds = 2.5f;
	double timeNow = theApplication.GetTimeFrameBegan();
	m_timeOfLastSpawn = timeNow + RandomFloat( 0.0f, (float)m_objectSpawnPeriodSeconds );
	m_objectSpawnType = ENT_ENEMY_MUSHROOM;
	m_anim = new Animation( "data/gfx/TreasureChest.tga" );
}


//-------------------------------------------------------------------------------------------------
// Think_GeneratorMushroom
//-------------------------------------------------------------------------------------------------
void Entity::Think_GeneratorMushroom()
{
	/// Check if generator is too far away from player
	float distSquared = DistanceSquaredBetweenPoints2d( theGame->m_player->pos, m_pos );
	if( distSquared > (MAX_SPAWNER_ACTIVE_DISTANCE * MAX_SPAWNER_ACTIVE_DISTANCE) )
		return;

	/// Check if spawn period has elapsed
	double timeNow = theApplication.GetTimeFrameBegan();
	double timeElapsed = timeNow - m_timeOfLastSpawn;
	if( timeElapsed > m_objectSpawnPeriodSeconds )
	{
		/// Spawn a new object of the appropriate type
		Entity& ent = SpawnNewEntity( m_objectSpawnType, m_pos );
		ent.m_rot = RandomFloat( 0.0f, 360.0f );
		m_timeOfLastSpawn = timeNow;
	}
}



//-------------------------------------------------------------------------------------------------
// Die_GeneratorMushroom
//-------------------------------------------------------------------------------------------------
void Entity::Die_GeneratorMushroom()
{
}



