//-------------------------------------------------------------------------------------------------
// Entity_Stunner.cpp
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "engineAssert.hpp"
#include "Entity.hpp"
#include "Particle.hpp"
#include "TheGame.hpp"


const double STUNNER_LIFESPAN_SECONDS = 3.0;
const float STUNNER_EXPLOSION_RADIUS = 5.0f;
const float STUNNER_MAX_DAMAGE = 0.0f;


//-------------------------------------------------------------------------------------------------
// Spawn_Stunner
//-------------------------------------------------------------------------------------------------
void Entity::Spawn_Stunner()
{
	theConsole.Printf( "Spawned a Stunner at %.02f,%.02f\n", m_pos.x, m_pos.y );
}


//-------------------------------------------------------------------------------------------------
// Think_Stunner
//-------------------------------------------------------------------------------------------------
void Entity::Think_Stunner()
{
	m_readyToDie = true;
}


//-------------------------------------------------------------------------------------------------
// Die_Stunner
//-------------------------------------------------------------------------------------------------
void Entity::Die_Stunner()
{
	delete m_anim ;

	Particle* p = Particle::Spawn();
	p->m_pos = m_pos;
	p->m_startAlpha = 1.0f;
	p->m_endAlpha = 0.0f;
	p->m_startScale = 0.0f;
	p->m_endScale = STUNNER_EXPLOSION_RADIUS;
	p->m_timeToLive = 0.35;
	p->m_anim = new Animation( "data/gfx/particles/StunnerExplode.tga" );

	DamageMapGridRadius( m_pos, STUNNER_EXPLOSION_RADIUS, false );
	DamageEntitiesRadius( m_pos, STUNNER_EXPLOSION_RADIUS, STUNNER_MAX_DAMAGE );

	/// Check if we hit the player
	if( theGame->IsPointWithinGivenRadiusOfPlayer( m_pos, STUNNER_EXPLOSION_RADIUS ) )
	{
		theGame->m_player->AdjustHealth( -STUNNER_MAX_DAMAGE * 0.5 );
	}
}



