//-------------------------------------------------------------------------------------------------
// Inventory.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
// 
// This source may not be used, modified, or distributed
//  without the express written permission of Brian 'Squirrel' Eiserloh.
//-------------------------------------------------------------------------------------------------
#ifndef _include_Inventory_
#define _include_Inventory_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"


enum
{
	ACTIVE_INVENTORY_ITEM_BOMB,
	ACTIVE_INVENTORY_ITEM_STUNNER,
	ACTIVE_INVENTORY_ITEM_HEALTH,
	ACTIVE_INVENTORY_ITEM_MANA,
	ACTIVE_INVENTORY_ITEM_INVISIBILITY,
	NUM_ACTIVE_INVENTORY_ITEMS,

	NUM_ORBS = 9,
};




///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Inventory
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class Inventory
{
private:
public:
	int			m_activeInventoryItemNumber;
	int			m_numKey;
	int			m_numBomb;
	int			m_numStunner;
	int			m_numHealth;
	int			m_numMana;
	int			m_numInvisibility;
	int			m_numOrb;

	/// Constructors / destructors
	Inventory(); // default constructor
	~Inventory(); // destructor

	void GiveItem( const char* itemName, int itemCount = 1 );
	void RemoveItem( const char* itemName, int itemCount = 1 );
	void UseCurrentActiveItem();
	void RotateCurrentActiveItem();
};


#endif // _include_Inventory_
