// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once
#include "Animation.hpp"
#include "Vector2.hpp"

class Particle
{
public:

	static std::list< Particle* > s_particleList;
	
	static inline Particle* Spawn();
	static void UpdateAll();
	static void DrawAll();

	Particle();
	~Particle();

	Vector2		m_pos;
	Animation*	m_anim;
	double		m_timeToLive;
	double		m_birthTime;
	float		m_startAlpha;
	float		m_endAlpha;
	float		m_startScale;
	float		m_endScale;
	float		m_rotVel;
	float		m_rot;
};


inline Particle* Particle::Spawn()
{
	Particle* p = new Particle();
	p->m_birthTime = theApplication.GetTimeFrameBegan();
	s_particleList.push_back( p );
	return p;
}