//-------------------------------------------------------------------------------------------------
// PlayerMagic.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
// 
// This source may not be used, modified, or distributed
//  without the express written permission of The Universe.
// Damn it feels good to be a gangsta.
//-------------------------------------------------------------------------------------------------


#include "pch.hpp"
#include "TheGame.hpp"
#include "Player.hpp"


//-------------------------------------------------------------------------------------------------
// Class constants
//-------------------------------------------------------------------------------------------------
STATIC const char*	Player::PLAYER_SPELL1					= "data/gfx/Spells/spell02.tga";
STATIC const char*	Player::PLAYER_SPELL2					= "data/gfx/Spells/spell06.tga";
STATIC const char*	Player::PLAYER_SPELL3					= "data/gfx/Spells/spell01.tga";
STATIC const char*	Player::PLAYER_SPELL4					= "data/gfx/Spells/spell01.tga";
STATIC const char*	Player::PLAYER_SPELL5					= "data/gfx/Spells/spell01.tga";
STATIC const char*	Player::PLAYER_SPELL6					= "data/gfx/Spells/spell01.tga";

STATIC float		Player::PLAYER_JUJU1FILLRATE			= 300.0f;
STATIC float		Player::PLAYER_JUJU2FILLRATE			= 1500.0f;
STATIC float		Player::PLAYER_JUJU3FILLRATE			= 250.0f;
STATIC float		Player::PLAYER_JUJU4FILLRATE			= 75.0f;
STATIC float		Player::PLAYER_JUJU5FILLRATE			= 30.0f;
STATIC float		Player::PLAYER_JUJU6FILLRATE			= 10.0f;

const float MANA_REGEN_PER_SECOND = 10.0f;


//-------------------------------------------------------------------------------------------------
// UpdateMagic
//-------------------------------------------------------------------------------------------------
void Player::UpdateMagic()
{
	double frameSeconds = theApplication.GetFrameSeconds();

	//-------------------------------------------------------------------------------------------------
	// Update Mana Regen
	//-------------------------------------------------------------------------------------------------
	AdjustMana( MANA_REGEN_PER_SECOND * (float)frameSeconds );

	//-------------------------------------------------------------------------------------------------
	// Update Invisibility countdown
	//-------------------------------------------------------------------------------------------------
	m_invisibilitySeconds -= frameSeconds;
	if( m_invisibilitySeconds < 0.0 )
	{
		m_invisibilitySeconds = 0.0;
	}

	//--------------------------------------------------------
	// Update Magic
	//--------------------------------------------------------
	float juju1ThisFrame = (float)(PLAYER_JUJU1FILLRATE * theApplication.GetFrameSeconds());
	juju1ThisFrame *= juju1Multiplier;
	
	float juju2ThisFrame = (float)(PLAYER_JUJU2FILLRATE * theApplication.GetFrameSeconds());
	juju2ThisFrame *= juju2Multiplier;
	
	float juju3ThisFrame = (float)(PLAYER_JUJU3FILLRATE * theApplication.GetFrameSeconds());
	juju3ThisFrame *= juju3Multiplier;

	float juju4ThisFrame = (float)(PLAYER_JUJU4FILLRATE * theApplication.GetFrameSeconds());
	juju4ThisFrame *= juju4Multiplier;

	float juju5ThisFrame = (float)(PLAYER_JUJU5FILLRATE * theApplication.GetFrameSeconds());
	juju5ThisFrame *= juju5Multiplier;

	float juju6ThisFrame = (float)(PLAYER_JUJU6FILLRATE * theApplication.GetFrameSeconds());
	juju6ThisFrame *= juju6Multiplier;

	juju1 += juju1ThisFrame;
	juju2 += juju2ThisFrame;
	juju3 += juju3ThisFrame;
	juju4 += juju4ThisFrame;
	juju5 += juju5ThisFrame;
	juju6 += juju6ThisFrame;

	if (juju1 > 200)
		juju1 = 200;
	if (juju2 > 200)
		juju2 = 200;
	if (juju3 > 200)
		juju3 = 200;
	if (juju4 > 200)
		juju4 = 200;
	if (juju5 > 200)
		juju5 = 200;
	if (juju6 > 200)
		juju6 = 200;
}


//-------------------------------------------------------------------------------------------------
// CastMagic
//-------------------------------------------------------------------------------------------------
void Player::CastMagic( int Spell )
{
	if (Spell == 1 && juju1 >= 200)
	{
		juju1 *= 0.5;
		
		Vector2 entPos = theGame->m_player->pos ;
		Entity& e = Entity::SpawnNewEntity( ENT_PLAYER_SPELL1, entPos );
		e.m_genericCounter = 300 ;
		e.m_rot = theGame->m_player->rotDeg ;
		AdjustMana( -5.0f );
	}
	else if (Spell == 2 && juju2 >= 200 && theGame->m_player->m_mana > 9.5)
	{
		juju2 *= 0.5;
	
		Vector2 entPos = theGame->m_player->pos ;
		Entity& e = Entity::SpawnNewEntity( ENT_PLAYER_SPELL2, entPos );
		e.m_genericCounter = 300 ;
		e.m_rot = theGame->m_player->rotDeg ;
		AdjustMana( -9.5f );
	}
	else if (Spell == 3 && juju3 >= 200 && theGame->m_player->m_mana > 25)
	{
		juju3 = 0;

//		Vector2 entPos = theGame->m_player->pos;
//		Entity& e = Entity::SpawnNewEntity( ENT_PLAYER_SPELL3, entPos );
//		e.m_genericCounter = 150;
//		e.m_rot = theGame->m_player->rotDeg;
//		AdjustMana( -25.0f );
	}
	else if (Spell == 4 && juju4 >= 200)
	{
		juju4 = 0;
		// Perform Spell
	}
	else if (Spell == 5 && juju5 >= 200)
	{
		juju5 = 0;
		// Perform Spell
	}
	else if (Spell == 6 && juju6 >= 200)
	{
		juju6 = 0;
		// Perform Spell
	}
}


//-------------------------------------------------------------------------------------------------
// IsInvisible
//-------------------------------------------------------------------------------------------------
bool Player::IsInvisible()
{
	return (m_invisibilitySeconds > 0.0);
}
