//-------------------------------------------------------------------------------------------------
// Scripting.hpp (engine)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_Scripting_
#define _include_Scripting_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"
#include "engineAssert.hpp"
#include "IntVector2.hpp"

///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		ScriptAction
// 
// Action verbs that can be executed by a material or entity.
///////////////////////////////////////////////////////////////////////////////////////////////////
class ScriptAction
{
public:
	std::string		m_actionName;
	std::string		m_actionArgs;
};


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		ScriptEventHandler
// 
// Events that this material or entity reacts / responds to.
///////////////////////////////////////////////////////////////////////////////////////////////////
class ScriptEventHandler
{
public:
	std::string					m_eventTypeName;
	std::list<ScriptAction>		m_scriptActions;
};


//-------------------------------------------------------------------------------------------------
// Extern'd functions
//-------------------------------------------------------------------------------------------------
void ExecuteScriptActions( const IntVector2& tilePosAtPointOfExecution, std::list<ScriptAction>& actionList );
void DamageMapGridXY( const IntVector2& location, bool isBomb );
void DamageMapGridRadius( const Vector2& center, float radius, bool isBomb );
void DamageEntitiesRadius( const Vector2& center, float radius, float maxDamage );


#endif // _include_Scripting_
