//-------------------------------------------------------------------------------------------------
// TheGameInterface.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
// 
// This source may not be used, modified, or distributed
//  without the express written permission of Brian 'Squirrel' Eiserloh.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "TheGameInterface.hpp"
#include "TheGame.hpp"
using namespace std;


//-------------------------------------------------------------------------------------------------
// Global singleton instance
//-------------------------------------------------------------------------------------------------
TheGameInterface theGameInterface;


//-------------------------------------------------------------------------------------------------
// Destructor()
//-------------------------------------------------------------------------------------------------
TheGameInterface::~TheGameInterface()
{
}


//-------------------------------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------------------------------
TheGameInterface::TheGameInterface()
{
}


//-------------------------------------------------------------------------------------------------
// PreInit
//-------------------------------------------------------------------------------------------------
void TheGameInterface::PreInit()
{
	theGame = new TheGame();
	VALIDATE( theGame );
	theGame->PreInit();
}


//-------------------------------------------------------------------------------------------------
// PostInit
//-------------------------------------------------------------------------------------------------
void TheGameInterface::PostInit()
{
	theGame->PostInit();
}


//-------------------------------------------------------------------------------------------------
// Shutdown
//-------------------------------------------------------------------------------------------------
void TheGameInterface::Shutdown()
{
}


//-------------------------------------------------------------------------------------------------
// RunFrame
//-------------------------------------------------------------------------------------------------
void TheGameInterface::RunFrame()
{
	theGame->RunFrame();
}


//-------------------------------------------------------------------------------------------------
// ProcessCommandLine
//-------------------------------------------------------------------------------------------------
VIRTUAL void TheGameInterface::ProcessCommandLine( string cmdLine )
{
}


//-------------------------------------------------------------------------------------------------
// ProcessInputEvent
//-------------------------------------------------------------------------------------------------
VIRTUAL const bool TheGameInterface::ProcessInputEvent( const TheInputSystem::inputEventType_e eventType, const byte_t key )
{
	if( eventType == TheInputSystem::INPUT_EVENT_KEYDOWN )
	{
		theGame->OnKeyDown( key );
	}
	else if( eventType == TheInputSystem::INPUT_EVENT_KEYUP )
	{
		theGame->OnKeyUp( key );
	}

	return false;
}
